/*
 * Author:      William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990-1993, William Cheng.
 *
 * Permission limited to the use, copy, modify, and distribute this software
 * and its documentation for any purpose is hereby granted by the Author without
 * fee, provided that the above copyright notice appear in all copies and
 * that both the copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the Author not be used
 * in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.  All other
 * rights (including the right to sell "tgif" and the right to sell derivative
 * works of tgif) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
 * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /amnt/kona/tangram/u/william/X11/TGIF2/RCS/page.e,v 2.5 1993/08/04 05:30:07 william Exp $
 */

#ifndef _PAGE_E_
#define _PAGE_E_

extern struct PageRec	* firstPage, * lastPage, * curPage;
extern int		curPageNum, lastPageNum;
extern int		paperRow, paperCol;
extern int		pageLayoutMode;
extern int		pageLineShownInTileMode;

extern char		* pageStackMenuStr[];
extern char		* pageTileMenuStr[];

extern void	InitPage ARGS_DECL((void));
extern void	GotoPageNum ARGS_DECL((int));
extern void	SetCurPage ARGS_DECL((int));
extern void	NextPage ARGS_DECL((void));
extern void	PrevPage ARGS_DECL((void));
extern void	NamePages ARGS_DECL((void));
extern void	GotoPage ARGS_DECL((void));
extern void	AddPageBefore ARGS_DECL((void));
extern void	AddPageAfter ARGS_DECL((void));
extern void	DeleteCurPage ARGS_DECL((void));
extern void	TogglePageLineShown ARGS_DECL((void));
extern void	SpecifyDrawingSize ARGS_DECL((void));
extern void	PrintOnePage ARGS_DECL((void));
extern void	PageSubMenu ARGS_DECL((int Index));
extern void	PageMenu ARGS_DECL((int X, int Y));
extern void	DelAllPages ARGS_DECL((void));
extern void	PageLayoutSubMenu ARGS_DECL((int Index));
extern void	PageLayoutMenu ARGS_DECL((int X, int Y));
extern void	CleanUpPage ARGS_DECL((void));
extern void	PushPageInfo ARGS_DECL((void));
extern void	PopPageInfo ARGS_DECL((void));

#endif /*_PAGE_E_*/
